﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GPS_recorder
{
    public partial class Form1 : Form
    {
        private System.IO.Ports.SerialPort NTL_SerialPort = new System.IO.Ports.SerialPort();
        private string COMPORT = "";
        
        public Form1()
        {
            InitializeComponent();


            timer1.Interval = 1;
            timer1.Tick += new EventHandler(timer1_Tick);
            timer1.Enabled = true;
        }

        void timer1_Tick(object sender, EventArgs e)
        {
            string[] pn = System.IO.Ports.SerialPort.GetPortNames();
            if (pn.Length == 0) return;
            if (COMPORT == "")
            {
                COMPORT = pn[0]; //【一つしかシリアルポートが接続されていない前提で選択】
                NTL_SerialPort.PortName = COMPORT; // Rohm基板はシリアルポート
                NTL_SerialPort.BaudRate = 4800;
                NTL_SerialPort.DataBits = 8;
                NTL_SerialPort.StopBits = System.IO.Ports.StopBits.One;
                NTL_SerialPort.Parity = System.IO.Ports.Parity.None;
                NTL_SerialPort.ReadTimeout = 2500;
                NTL_SerialPort.ReadBufferSize = 1024; //【受信データバッファサイズ】
                NTL_SerialPort.WriteBufferSize = 256;
                NTL_SerialPort.DtrEnable = true; // DTR有効
                NTL_SerialPort.RtsEnable = true; // RTS有効
                try { NTL_SerialPort.Open(); }
                catch (Exception) { MessageBox.Show("シリアルポートが開けません"); return; }
            }
            else
            {
                if (NTL_SerialPort.BytesToRead == 0) return;
                textBox1.Text += NTL_SerialPort.ReadLine()+"\n";
                textBox1.SelectionStart = textBox1.Text.Length;
                textBox1.Focus();
                textBox1.ScrollToCaret();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            NTL_SerialPort.Close();
            System.IO.StreamWriter sw = new System.IO.StreamWriter(
                "GPSLog.txt",
                false,
                System.Text.Encoding.GetEncoding("shift_jis") );
            sw.Write(textBox1.Text);
            sw.Close();
            this.Close();
        }
    }
}
